//=============================================================================
//  eLXg TGPBitmap 摜 1 ̃t@Cɂĕۑ
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2025N0423 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//   Windows 10 rh 19045 Pro 64 bit + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls,
  StdCtrls, GDIPOBJ, GDIPAPI, GDIPUTIL;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Image1: TImage;
    Memo1: TMemo;
    Button3: TButton;
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    FGPBitmap : TGPBitmap;
  end;

  function WriteImageText(AFilePath: string; AGPBitmap: TGPBitmap;
    AText: string): Integer;
  function ReadImageText(AFilePath: string; var AGPBitmap: TGPBitmap;
    var AText: string): Integer;
  function BitmapToGPBitmap(SrcBitmap: TBitmap; DstGPBitmap: TGPBitmap): Boolean;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  ImageBMPClsid  : TGUID = '{557CF400-1A04-11D3-9A73-0000F81EF32E}';
  ImageJPEGClsid : TGUID = '{557CF401-1A04-11D3-9A73-0000F81EF32E}';
  ImageGIFClsid  : TGUID = '{557CF402-1A04-11D3-9A73-0000F81EF32E}';
  ImageTIFFClsid : TGUID = '{557CF405-1A04-11D3-9A73-0000F81EF32E}';
  ImagePNGClsid  : TGUID = '{557CF406-1A04-11D3-9A73-0000F81EF32E}';

//=============================================================================
//  tH[j̏
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(FGPBitmap) then FreeAndNil(FGPBitmap);
end;

//=============================================================================
//  VK摜
//  FGPBitmap ͌ݑ쒆 TGPBitmap ̃CX^X
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LImgFilePath : string;
  LGPGraphics  : TGPGraphics;
  LBitmap      : TBitmap;
begin
  if Assigned(FGPBitmap) then FreeAndNil(FGPBitmap);
  Image1.Picture.Assign(nil);
  Memo1.Lines.Clear;

  LImgFilePath := 'bug.bmp';

  LBitmap := TBitmap.Create;
  try
    // 摜t@Cǂݍ TImage ɕ`
    if LowerCase(ExtractFileExt(LImgFilePath)) = '.bmp' then begin
      LBitmap.LoadFromFile(LImgFilePath);
      FGPBitmap := TGPBitmap.Create(LBitmap.Width, LBitmap.Height);
      BitmapToGPBitmap(LBitmap, FGPBitmap);
  end else begin
    FGPBitmap := TGPBitmap.Create(LImgFilePath);
  end;

    // ` TImage.Canvas ɂĉ摜`
    LGPGraphics := TGPGraphics.Create(Image1.Canvas.Handle);
    LGPGraphics.DrawImage(FGPBitmap, 0, 0, Image1.Width, Image1.Height);

    // eLXg
@  Memo1.Lines.Text := 'egE';
  finally
    FreeAndNil(LBitmap);
    FreeAndNil(LGPGraphics);
  end;
end;

//=============================================================================
///  ۑENA
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LText : string;
begin
  LText := Memo1.Lines.text;
  if writeImageText('aaa.dat', FGPBitmap, LText) = 0 then Exit;

  Image1.Picture.Assign(nil);
  Memo1.Lines.Clear;
end;

//=============================================================================
///  ǂݏo
//=============================================================================
procedure TForm1.Button3Click(Sender: TObject);
var
  LGPGraphics : TGPGraphics;
  LText       : string;
begin
  Image1.Picture.Assign(nil);
  Memo1.Lines.Clear;
  if ReadImageText('aaa.dat', FGPBitmap, LText) = 0 then Exit;

  Memo1.Lines.Text := LText;

  LGPGraphics := TGPGraphics.Create(Image1.Canvas.Handle);
  LGPGraphics.DrawImage(FGPBitmap, 0, 0, Image1.Width, Image1.Height);
  FreeAndNil(LGPGraphics);
end;

    //-----------------------------------------------------------------------------
//  eLXg + TGPBitmap t@Cւ̏ݗp֐
//  ߂l͏񂾃oCg
//-----------------------------------------------------------------------------
function WriteImageText(AFilePath: string; AGPBitmap: TGPBitmap;
  AText: string): Integer;
var
  LFileStream : TFileStream;
  LByteStream : TBytesStream;
  LStrList    : TStringList;
  LByteSize   : Integer;
  LImageGUID  : TGUID;
begin
  Result := 0;
  if not Assigned(AGPBitmap) then Exit;
  DeleteFile(AFilePath);

  LFileStream := TFileStream.Create(AFilePath, fmCreate);
  LByteStream := TBytesStream.Create;
  LStrList    := TStringList.Create;
  try
    LStrList.Text := AText;
    LByteStream.Clear;
    LStrList.SaveToStream(LByteStream, TEncoding.Unicode);
    LByteSize := LByteStream.Size;
    LFileStream.WriteData(LByteSize);
    LFileStream.Write(LByteStream.Bytes[0], LByteSize);

    LByteStream.Clear;
    GetEncoderClsid('image/png', LImageGUID);
    AGPBitmap.Save(TStreamAdapter.Create(LByteStream), LImageGUID);
    LByteSize := LByteStream.Size;
    LFileStream.WriteData(LByteSize);
    LFileStream.Write(LByteStream.Bytes[0], LByteSize);

    Result := LFileStream.Position;
  finally
    FreeAndNil(LFileStream);
    FreeAndNil(LByteStream);
    FreeAndNil(LStrList);
  end;
end;

    //-----------------------------------------------------------------------------
//  eLXg + TGPBitmap t@C̓ǂݏop֐
//  ߂l͓ǂݏooCg
//-----------------------------------------------------------------------------
function ReadImageText(AFilePath: string; var AGPBitmap: TGPBitmap;
  var AText: string): Integer;
var
  LFileStream : TFileStream;
  LByteStream : TBytesStream;
  LStrList    : TStringList;
  LByteSize   : Integer;
begin
  Result := 0;
  if not FileExists(AFilePath) then Exit;


  if Assigned(AGPBitmap) then FreeAndNil(AGPBitmap);

  LFileStream := TFileStream.Create(AFilePath, fmOpenRead);
  LByteStream := TBytesStream.Create;
  LStrList    := TstringList.Create;
  try
    TFileStream(LFileStream).ReadData(LByteSize);
    LByteStream.Size := LByteSize;
    LFileStream.Read(LByteStream.Bytes[0], LByteSize);
    LByteStream.Position := 0;
    LStrList.LoadFromStream(LByteStream, TEncoding.Unicode);
    AText := LStrList.Text;

    LFileStream.ReadData(LByteSize);
    LByteStream.Size := LByteSize;
    LFileStream.Read(LByteStream.Bytes[0], LByteSize);
    AGPBitmap := TGPBitmap.Create(TStreamAdapter.Create(LByteStream));

    Result := LFileStream.Position;
  finally
    FreeAndNil(LFileStream);
    FreeAndNil(LByteStream);
    FreeAndNil(LStrList);
  end;
end;

//-----------------------------------------------------------------------------
//  TBitmap At@l TGPBitmap ɕϊ
//-----------------------------------------------------------------------------
function BitmapToGPBitmap(SrcBitmap: TBitmap; DstGPBitmap: TGPBitmap): Boolean;
type
  TRGBQArray = array [0..4095] of RGBQUAD;
  PRGBQArray = ^TRGBQArray;
var
  LBmpData    : TBitmapData;
  LScanLine   : PByte;
  LpRGBQuad   : PRGBQuad;
  LWidth      : Integer;
  LHeight     : Integer;
  LDataStride : Integer;
  LXPos       : integer;
  LYPos       : Integer;
  LScanArray  : PRGBQArray;
  LAValue     : Byte;
  LRValue     : Byte;
  LGValue     : Byte;
  LBValue     : Byte;
begin
  Result := False;

  SrcBitmap.PixelFormat := pf32bit;

  LWidth  := SrcBitmap.Width;
  LHeight := SrcBitmap.Height;

  SrcBitmap.Canvas.Lock;
  if DstGPBitmap.LockBits(MakeRect(0, 0, LWidth, LHeight), ImageLockModeWrite,
                                   PixelFormat32bppARGB, LBmpData) <> Ok then exit;

  LScanLine   := LBmpData.Scan0;
  LDataStride := LBmpData.Stride;

  for LYPos := 0 to LHeight - 1 do begin
    LpRGBQuad  := PRGBQuad(LScanLine);
    LScanArray := SrcBitmap.ScanLine[LYPos];

    for LXPos := 0 to LWidth - 1 do begin

      LAValue := LScanArray[LXPos].rgbReserved;
      LRValue := LScanArray[LXPos].rgbRed;
      LGValue := LScanArray[LXPos].rgbGreen;
      LBValue := LScanArray[LXPos].rgbBlue;

      if (RGB(LRValue, LGValue, LBValue) = 0) and (LAValue = 0) then begin
        LpRGBQuad^.rgbReserved :=  0;
      end else
      if (LAValue = 0) then begin
        LpRGBQuad^.rgbReserved := $FF;
      end else begin
        LpRGBQuad^.rgbRed := LRValue;
        LpRGBQuad^.rgbGreen := LGValue;
        LpRGBQuad^.rgbBlue := LBValue;
        LpRGBQuad^.rgbReserved := LScanArray[LXPos].rgbReserved;
      end;
      //F̓hׂ̐Fw肪SARGBŎw\ł΂1sł悢
      //LpRGBQuad^.rgbReserved := LScanArray[LXPos].rgbReserved;
      Inc(LpRGBQuad);
    end;
    Inc(LScanLine, LDataStride);
  end;

  Result := True;
  DstGPBitmap.UnlockBits(LBmpData);
  SrcBitmap.Canvas.Unlock;
end;


end.

end.

